<?php

# Download CryptoPhoto PHP lib from https://cryptophoto.com/admin/api
include("CryptoPhotoUtils.php");

$server      = "https://cryptophoto.com";
$private_key = "xxx"; # Your CryptoPhoto Private API Key
$public_key  = "yyy"; # Your CryptoPhoto Public API Key
$salt        = "random-salt-string";
$uid         = "userId"; # Your users internal ID
$tvkey       = "key-of-a-transaction-verification-template"; # see https://cryptophoto.com/info/cptv-templates and https://cryptophoto.com/admin/api-docs#header-ecryption-and-decryption

$success = "";
$error = "";
$sid = '';
$value = "";
$doingDecryption = false;

if (isset($_POST['value_cpencrypt']) && isset($_POST['value']) && $_POST['value']) {

  if (isset($_POST['cpJWSrfc7515']) && isset($_POST['cpTVresponse'])) {

    $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1($uid . $salt));

    $cp->verify_cptv_response($_POST); // verify transaction response

    if ($cp->is_valid) {// response validate

      if ($_POST['cpTVresponse'] == "approve") {
        $success = "value encrypted";
        $value = $_POST['value'];
        $doingDecryption = true;
      }

    } else {
      $error = $cp->error;
    }
  }
} else if (isset($_POST['value_cpdecrypt']) && isset($_POST['value']) && $_POST['value']) {

  if (isset($_POST['cpJWSrfc7515']) && isset($_POST['cpTVresponse'])) {

    $cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1($uid . $salt));
    
    $cp->verify_cptv_response($_POST); // verify transaction response

    if ($cp->is_valid) {// response validate

      if ($_POST['cpTVresponse'] == "approve") {
        $success = "value decrypted";
        $value = $_POST['value'];
        $doingDecryption = false;
      }

    } else {
      $error = $cp->error;
    }
  }
}

$cp = new CryptoPhotoUtils($server, $private_key, $public_key, sha1($uid . $salt));
$cp->start_session($_SERVER['REMOTE_ADDR'], false);

if ($cp->is_valid) {
  $sid = $cp->sid;
} else {
  $error = $cp->error . ( $cp->errdesc ? ' ' . $cp->errdesc : '' );
}

?><!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Encrypt/Decrypt Value</title>
</head>

<body style="text-align:center">
  <h2>Encrypt/Decrypt Value</h2>
  <form action="" method="post">
    <?php if ($success) { ?><p>Success: <?php echo $success ?></p><?php } ?>
    <?php if ($error) { ?><p>Error: <?php echo $error ?></p><?php } ?>
    Value:<br> <textarea rows="5" name="value" ><?php echo $value?></textarea><br>

<?php if(!$doingDecryption) { ?>
    <input type="hidden" name="value_cpencrypt" value="true">
    <input type="submit" value="Encrypt">
<?php } else { ?>
    <input type="hidden" name="value_cpdecrypt" value="true">
    <input type="submit" value="Decrypt">
<?php } ?>
    
  </form>
  <script type='text/javascript' src='<?php echo $server ?>/api/tv?key=<?php echo $tvkey ?>&sid=<?php echo $sid ?>' async='true'></script>
</body>
</html>